# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/storage/property/base'

module Google
  module Storage
    module Property
      # A Puppet property that can compare its values
      class Array < Google::Storage::Property::Base
        # Sets Google::Storage::Property::Array to match all elements, not any.
        def self.match_all_array
          self.array_matching = :all
        end

        # When the user specifies an array for a property Puppet by default
        # ensures that at least 1 of the values match. This is useful when you
        # have various options and any match is good, e.g. various possible file
        # sources, say from Corp or Internet.
        #
        # However our arrays require that all values match so we define the
        # array_matching = :all to instruct Puppet to do this. This could have
        # been specified in the Puppet::Type, but putting it here makes it
        # simpler to not "forget" to define it.
        match_all_array

        def match_all?
          true
        end

        def self.api_munge(value)
          value
        end
      end
    end
  end
end
