# Copyright 2018 Google Inc.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# ----------------------------------------------------------------------------
#
#     ***     AUTO GENERATED CODE    ***    AUTO GENERATED CODE     ***
#
# ----------------------------------------------------------------------------
#
#     This file is automatically generated by Magic Modules and manual
#     changes will be clobbered when the file is regenerated.
#
#     Please read more about how to change this file in README.md and
#     CONTRIBUTING.md located at the root of this package.
#
# ----------------------------------------------------------------------------

require 'google/storage/property/array'
require 'google/storage/property/base'

module Google
  module Storage
    module Data
      # A class to manage data for Rule for bucket.
      class BucketRule
        include Comparable

        attr_reader :action
        attr_reader :condition

        def to_json(_arg = nil)
          {
            'action' => action,
            'condition' => condition
          }.reject { |_k, v| v.nil? }.to_json
        end

        def to_s
          {
            action: action,
            condition: condition
          }.reject { |_k, v| v.nil? }.map { |k, v| "#{k}: #{v}" }.join(', ')
        end

        def ==(other)
          return false unless other.is_a? BucketRule
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            return false if compare[:self] != compare[:other]
          end
          true
        end

        def <=>(other)
          return false unless other.is_a? BucketRule
          compare_fields(other).each do |compare|
            next if compare[:self].nil? || compare[:other].nil?
            result = compare[:self] <=> compare[:other]
            return result unless result.zero?
          end
          0
        end

        private

        def compare_fields(other)
          [
            { self: action, other: other.action },
            { self: condition, other: other.condition }
          ]
        end
      end

      # Manages a BucketRule nested object
      # Data is coming from the GCP API
      class BucketRuleApi < BucketRule
        def initialize(args)
          @action = Google::Storage::Property::BucketAction.api_munge(args['action'])
          @condition = Google::Storage::Property::BucketCondition.api_munge(args['condition'])
        end
      end

      # Manages a BucketRule nested object
      # Data is coming from the Puppet manifest
      class BucketRuleCatalog < BucketRule
        def initialize(args)
          @action = Google::Storage::Property::BucketAction.unsafe_munge(args['action'])
          @condition = Google::Storage::Property::BucketCondition.unsafe_munge(args['condition'])
        end
      end
    end

    module Property
      # A class to manage input to Rule for bucket.
      class BucketRule < Google::Storage::Property::Base
        # Used for parsing Puppet catalog
        def unsafe_munge(value)
          self.class.unsafe_munge(value)
        end

        # Used for parsing Puppet catalog
        def self.unsafe_munge(value)
          return if value.nil?
          Data::BucketRuleCatalog.new(value)
        end

        # Used for parsing GCP API responses
        def self.api_munge(value)
          return if value.nil?
          Data::BucketRuleApi.new(value)
        end
      end

      # A Puppet property that holds an integer
      class BucketRuleArray < Google::Storage::Property::Array
        # Used for parsing Puppet catalog
        def unsafe_munge(value)
          self.class.unsafe_munge(value)
        end

        # Used for parsing Puppet catalog
        def self.unsafe_munge(value)
          return if value.nil?
          return BucketRule.unsafe_munge(value) \
            unless value.is_a?(::Array)
          value.map { |v| BucketRule.unsafe_munge(v) }
        end

        # Used for parsing GCP API responses
        def self.api_munge(value)
          return if value.nil?
          return BucketRule.api_munge(value) \
            unless value.is_a?(::Array)
          value.map { |v| BucketRule.api_munge(v) }
        end
      end
    end
  end
end
